/* helpers.c generated by valac 0.56.7, the Vala compiler
 * generated from helpers.vala, do not modify */

/*
 * Copyright 2018 (C) Raster Software Vigo (Sergio Costas)
 *
 * This file is part of Cronopete
 *
 * Cronopete is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 *
 * Cronopete is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdio.h>

#define CONSTANTS_PKGDATADIR "/usr/share/cronopete"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define CRONOPETE_TYPE_FOLDER_CONTAINER (cronopete_folder_container_get_type ())
typedef struct _cronopetefolder_container cronopetefolder_container;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _cronopetefolder_container {
	gchar* folder;
	gchar** exclude;
	gint exclude_length1;
	gint _exclude_size_;
	gboolean valid;
};

VALA_EXTERN gchar* cronopete_date_to_string (time_t datetime);
VALA_EXTERN GType cronopete_folder_container_get_type (void) G_GNUC_CONST ;
VALA_EXTERN cronopetefolder_container* cronopete_folder_container_dup (const cronopetefolder_container* self);
VALA_EXTERN void cronopete_folder_container_free (cronopetefolder_container* self);
VALA_EXTERN void cronopete_folder_container_copy (const cronopetefolder_container* self,
                                      cronopetefolder_container* dest);
VALA_EXTERN void cronopete_folder_container_destroy (cronopetefolder_container* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (cronopetefolder_container, cronopete_folder_container_destroy)
VALA_EXTERN void cronopete_folder_container_init (cronopetefolder_container *self,
                                      const gchar* folder,
                                      gchar** exclude_list,
                                      gint exclude_list_length1,
                                      gboolean skip_hidden_at_home);
static void _vala_array_add13 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static void _vala_array_add14 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
VALA_EXTERN void cronopete_show_error_window (const gchar* msg,
                                  GtkWindow* parent_window);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

gchar*
cronopete_date_to_string (time_t datetime)
{
	GDateTime* last_backup = NULL;
	GDateTime* _tmp1_;
	gint lb_day = 0;
	GDateTime* _tmp2_;
	gint lb_month = 0;
	GDateTime* _tmp3_;
	gint lb_year = 0;
	GDateTime* _tmp4_;
	time_t now = 0;
	time_t _tmp5_;
	GDateTime* today = NULL;
	GDateTime* _tmp6_;
	GDateTime* yesterday = NULL;
	GDateTime* _tmp7_;
	GDateTime* tomorrow = NULL;
	GDateTime* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	GDateTime* _tmp11_;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	GDateTime* _tmp18_;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	GDateTime* _tmp25_;
	gchar* result;
#line 23 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (datetime == ((time_t) 0)) {
#line 121 "helpers.c"
		gchar* _tmp0_;
#line 25 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp0_ = g_strdup (_ ("Not available"));
#line 25 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		result = _tmp0_;
#line 25 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		return result;
#line 129 "helpers.c"
	}
#line 28 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp1_ = g_date_time_new_from_unix_local ((gint64) datetime);
#line 28 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	last_backup = _tmp1_;
#line 29 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp2_ = last_backup;
#line 29 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	lb_day = g_date_time_get_day_of_month (_tmp2_);
#line 30 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp3_ = last_backup;
#line 30 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	lb_month = g_date_time_get_month (_tmp3_);
#line 31 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp4_ = last_backup;
#line 31 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	lb_year = g_date_time_get_year (_tmp4_);
#line 32 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp5_ = time (NULL);
#line 32 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	now = _tmp5_;
#line 33 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp6_ = g_date_time_new_from_unix_local ((gint64) now);
#line 33 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	today = _tmp6_;
#line 34 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp7_ = g_date_time_new_from_unix_local ((gint64) (now - 86400));
#line 34 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	yesterday = _tmp7_;
#line 35 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp8_ = g_date_time_new_from_unix_local ((gint64) (now + 86400));
#line 35 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	tomorrow = _tmp8_;
#line 38 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp11_ = today;
#line 38 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (lb_day == g_date_time_get_day_of_month (_tmp11_)) {
#line 167 "helpers.c"
		GDateTime* _tmp12_;
#line 38 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp12_ = today;
#line 38 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp10_ = lb_month == g_date_time_get_month (_tmp12_);
#line 173 "helpers.c"
	} else {
#line 38 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp10_ = FALSE;
#line 177 "helpers.c"
	}
#line 38 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (_tmp10_) {
#line 181 "helpers.c"
		GDateTime* _tmp13_;
#line 38 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp13_ = today;
#line 38 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp9_ = lb_year == g_date_time_get_year (_tmp13_);
#line 187 "helpers.c"
	} else {
#line 38 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp9_ = FALSE;
#line 191 "helpers.c"
	}
#line 38 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (_tmp9_) {
#line 195 "helpers.c"
		GDateTime* _tmp14_;
		gchar* _tmp15_;
#line 40 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp14_ = last_backup;
#line 40 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp15_ = g_date_time_format (_tmp14_, _ ("today at %R"));
#line 40 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		result = _tmp15_;
#line 40 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (tomorrow);
#line 40 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (yesterday);
#line 40 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (today);
#line 40 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (last_backup);
#line 40 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		return result;
#line 214 "helpers.c"
	}
#line 42 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp18_ = yesterday;
#line 42 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (lb_day == g_date_time_get_day_of_month (_tmp18_)) {
#line 220 "helpers.c"
		GDateTime* _tmp19_;
#line 42 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp19_ = yesterday;
#line 42 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp17_ = lb_month == g_date_time_get_month (_tmp19_);
#line 226 "helpers.c"
	} else {
#line 42 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp17_ = FALSE;
#line 230 "helpers.c"
	}
#line 42 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (_tmp17_) {
#line 234 "helpers.c"
		GDateTime* _tmp20_;
#line 42 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp20_ = yesterday;
#line 42 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp16_ = lb_year == g_date_time_get_year (_tmp20_);
#line 240 "helpers.c"
	} else {
#line 42 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp16_ = FALSE;
#line 244 "helpers.c"
	}
#line 42 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (_tmp16_) {
#line 248 "helpers.c"
		GDateTime* _tmp21_;
		gchar* _tmp22_;
#line 44 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp21_ = last_backup;
#line 44 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp22_ = g_date_time_format (_tmp21_, _ ("yesterday at %R"));
#line 44 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		result = _tmp22_;
#line 44 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (tomorrow);
#line 44 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (yesterday);
#line 44 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (today);
#line 44 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (last_backup);
#line 44 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		return result;
#line 267 "helpers.c"
	}
#line 46 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp25_ = tomorrow;
#line 46 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (lb_day == g_date_time_get_day_of_month (_tmp25_)) {
#line 273 "helpers.c"
		GDateTime* _tmp26_;
#line 46 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp26_ = tomorrow;
#line 46 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp24_ = lb_month == g_date_time_get_month (_tmp26_);
#line 279 "helpers.c"
	} else {
#line 46 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp24_ = FALSE;
#line 283 "helpers.c"
	}
#line 46 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (_tmp24_) {
#line 287 "helpers.c"
		GDateTime* _tmp27_;
#line 46 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp27_ = tomorrow;
#line 46 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp23_ = lb_year == g_date_time_get_year (_tmp27_);
#line 293 "helpers.c"
	} else {
#line 46 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp23_ = FALSE;
#line 297 "helpers.c"
	}
#line 46 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (_tmp23_) {
#line 301 "helpers.c"
		GDateTime* _tmp28_;
		gchar* _tmp29_;
#line 48 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp28_ = last_backup;
#line 48 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp29_ = g_date_time_format (_tmp28_, _ ("tomorrow at %R"));
#line 48 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		result = _tmp29_;
#line 48 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (tomorrow);
#line 48 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (yesterday);
#line 48 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (today);
#line 48 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (last_backup);
#line 48 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		return result;
#line 320 "helpers.c"
	} else {
		GDateTime* _tmp30_;
		gchar* _tmp31_;
#line 51 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp30_ = last_backup;
#line 51 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp31_ = g_date_time_format (_tmp30_, _ ("%B %e, %Y at %R"));
#line 51 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		result = _tmp31_;
#line 51 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (tomorrow);
#line 51 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (yesterday);
#line 51 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (today);
#line 51 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_date_time_unref0 (last_backup);
#line 51 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		return result;
#line 340 "helpers.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 364 "helpers.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 373 "helpers.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 392 "helpers.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 396 "helpers.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 402 "helpers.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 412 "helpers.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 420 "helpers.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 424 "helpers.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 430 "helpers.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 440 "helpers.c"
}

static void
_vala_array_add13 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 78 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if ((*length) == (*size)) {
#line 78 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 78 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 455 "helpers.c"
	}
#line 78 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*array)[(*length)++] = value;
#line 78 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*array)[*length] = NULL;
#line 461 "helpers.c"
}

static void
_vala_array_add14 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 84 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if ((*length) == (*size)) {
#line 84 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 84 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 476 "helpers.c"
	}
#line 84 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*array)[(*length)++] = value;
#line 84 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*array)[*length] = NULL;
#line 482 "helpers.c"
}

void
cronopete_folder_container_init (cronopetefolder_container *self,
                                 const gchar* folder,
                                 gchar** exclude_list,
                                 gint exclude_list_length1,
                                 gboolean skip_hidden_at_home)
{
	gchar** _tmp2_;
	gchar* home_folder = NULL;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gboolean _tmp18_ = FALSE;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
#line 60 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	g_return_if_fail (folder != NULL);
#line 60 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	memset (self, 0, sizeof (cronopetefolder_container));
#line 61 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*self).valid = TRUE;
#line 62 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (!g_str_has_suffix (folder, "/")) {
#line 507 "helpers.c"
		gchar* _tmp0_;
#line 63 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp0_ = g_strconcat (folder, "/", NULL);
#line 63 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_free0 ((*self).folder);
#line 63 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		(*self).folder = _tmp0_;
#line 515 "helpers.c"
	} else {
		gchar* _tmp1_;
#line 65 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp1_ = g_strdup (folder);
#line 65 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_free0 ((*self).folder);
#line 65 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		(*self).folder = _tmp1_;
#line 524 "helpers.c"
	}
#line 67 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp2_ = g_new0 (gchar*, 0 + 1);
#line 67 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*self).exclude = (_vala_array_free ((*self).exclude, (*self).exclude_length1, (GDestroyNotify) g_free), NULL);
#line 67 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*self).exclude = _tmp2_;
#line 67 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*self).exclude_length1 = 0;
#line 67 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*self)._exclude_size_ = (*self).exclude_length1;
#line 536 "helpers.c"
	{
		gchar** x_collection = NULL;
		gint x_collection_length1 = 0;
		gint _x_collection_size_ = 0;
		gint x_it = 0;
#line 68 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		x_collection = exclude_list;
#line 68 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		x_collection_length1 = exclude_list_length1;
#line 68 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		for (x_it = 0; x_it < x_collection_length1; x_it = x_it + 1) {
#line 548 "helpers.c"
			gchar* _tmp3_;
			gchar* x = NULL;
#line 68 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
			_tmp3_ = g_strdup (x_collection[x_it]);
#line 68 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
			x = _tmp3_;
#line 555 "helpers.c"
			{
				const gchar* _tmp4_;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
#line 69 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
				_tmp4_ = x;
#line 69 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
				if (!g_str_has_suffix (_tmp4_, "/")) {
#line 566 "helpers.c"
					const gchar* _tmp5_;
					gchar* _tmp6_;
#line 70 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					_tmp5_ = x;
#line 70 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					_tmp6_ = g_strconcat (_tmp5_, "/", NULL);
#line 70 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					_g_free0 (x);
#line 70 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					x = _tmp6_;
#line 577 "helpers.c"
				}
#line 72 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
				_tmp7_ = x;
#line 72 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
				_tmp8_ = (*self).folder;
#line 72 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
				if (g_strcmp0 (_tmp7_, _tmp8_) == 0) {
#line 73 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					(*self).valid = FALSE;
#line 74 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					_g_free0 (x);
#line 74 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					break;
#line 591 "helpers.c"
				}
#line 76 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
				_tmp9_ = x;
#line 76 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
				_tmp10_ = (*self).folder;
#line 76 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
				if (g_str_has_prefix (_tmp9_, _tmp10_)) {
#line 599 "helpers.c"
					const gchar* _tmp11_;
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					gchar* _tmp15_;
#line 78 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					_tmp11_ = x;
#line 78 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					_tmp12_ = (*self).folder;
#line 78 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					_tmp13_ = strlen (_tmp12_);
#line 78 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					_tmp14_ = _tmp13_;
#line 78 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					_tmp15_ = string_substring (_tmp11_, (glong) (_tmp14_ - 1), (glong) -1);
#line 78 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
					_vala_array_add13 (&(*self).exclude, &(*self).exclude_length1, &(*self)._exclude_size_, _tmp15_);
#line 617 "helpers.c"
				}
#line 68 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
				_g_free0 (x);
#line 621 "helpers.c"
			}
		}
	}
#line 82 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp16_ = g_get_home_dir ();
#line 82 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp17_ = g_strconcat (_tmp16_, "/", NULL);
#line 82 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	home_folder = _tmp17_;
#line 83 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp19_ = (*self).folder;
#line 83 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp20_ = home_folder;
#line 83 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (g_strcmp0 (_tmp19_, _tmp20_) == 0) {
#line 83 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp18_ = skip_hidden_at_home;
#line 639 "helpers.c"
	} else {
#line 83 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp18_ = FALSE;
#line 643 "helpers.c"
	}
#line 83 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (_tmp18_) {
#line 647 "helpers.c"
		gchar* _tmp21_;
#line 84 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp21_ = g_strdup ("/.*");
#line 84 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_vala_array_add14 (&(*self).exclude, &(*self).exclude_length1, &(*self)._exclude_size_, _tmp21_);
#line 653 "helpers.c"
	}
#line 60 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_g_free0 (home_folder);
#line 657 "helpers.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (length >= 0) {
#line 666 "helpers.c"
		gchar** result;
		gssize i;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		result = g_new0 (gchar*, length + 1);
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		for (i = 0; i < length; i++) {
#line 673 "helpers.c"
			gchar* _tmp0_;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
			_tmp0_ = g_strdup (self[i]);
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
			result[i] = _tmp0_;
#line 679 "helpers.c"
		}
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		return result;
#line 683 "helpers.c"
	}
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	return NULL;
#line 687 "helpers.c"
}

void
cronopete_folder_container_copy (const cronopetefolder_container* self,
                                 cronopetefolder_container* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp0_ = (*self).folder;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_g_free0 ((*dest).folder);
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*dest).folder = _tmp1_;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp2_ = (*self).exclude;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp2__length1 = (*self).exclude_length1;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup1 (_tmp2_, _tmp2__length1) : _tmp2_;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp3__length1 = _tmp2__length1;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*dest).exclude = (_vala_array_free ((*dest).exclude, (*dest).exclude_length1, (GDestroyNotify) g_free), NULL);
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*dest).exclude = _tmp3_;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*dest).exclude_length1 = _tmp3__length1;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*dest)._exclude_size_ = (*dest).exclude_length1;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*dest).valid = (*self).valid;
#line 726 "helpers.c"
}

void
cronopete_folder_container_destroy (cronopetefolder_container* self)
{
#line 56 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_g_free0 ((*self).folder);
#line 57 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	(*self).exclude = (_vala_array_free ((*self).exclude, (*self).exclude_length1, (GDestroyNotify) g_free), NULL);
#line 736 "helpers.c"
}

cronopetefolder_container*
cronopete_folder_container_dup (const cronopetefolder_container* self)
{
	cronopetefolder_container* dup;
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	dup = g_new0 (cronopetefolder_container, 1);
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	cronopete_folder_container_copy (self, dup);
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	return dup;
#line 749 "helpers.c"
}

void
cronopete_folder_container_free (cronopetefolder_container* self)
{
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	cronopete_folder_container_destroy (self);
#line 55 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	g_free (self);
#line 759 "helpers.c"
}

static GType
cronopete_folder_container_get_type_once (void)
{
	GType cronopete_folder_container_type_id;
	cronopete_folder_container_type_id = g_boxed_type_register_static ("cronopetefolder_container", (GBoxedCopyFunc) cronopete_folder_container_dup, (GBoxedFreeFunc) cronopete_folder_container_free);
	return cronopete_folder_container_type_id;
}

GType
cronopete_folder_container_get_type (void)
{
	static volatile gsize cronopete_folder_container_type_id__once = 0;
	if (g_once_init_enter (&cronopete_folder_container_type_id__once)) {
		GType cronopete_folder_container_type_id;
		cronopete_folder_container_type_id = cronopete_folder_container_get_type_once ();
		g_once_init_leave (&cronopete_folder_container_type_id__once, cronopete_folder_container_type_id);
	}
	return cronopete_folder_container_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 99 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	return self ? g_object_ref (self) : NULL;
#line 787 "helpers.c"
}

void
cronopete_show_error_window (const gchar* msg,
                             GtkWindow* parent_window)
{
	FILE* _tmp0_;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp1_;
	GtkLabel* label = NULL;
	GtkBuilder* _tmp9_;
	GObject* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkDialog* w = NULL;
	GtkBuilder* _tmp13_;
	GObject* _tmp14_;
	GtkDialog* _tmp15_;
	GtkDialog* _tmp17_;
	GtkDialog* _tmp18_;
	GtkDialog* _tmp19_;
	GtkDialog* _tmp20_;
	GError* _inner_error0_ = NULL;
#line 89 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	g_return_if_fail (msg != NULL);
#line 90 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp0_ = stdout;
#line 90 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	fprintf (_tmp0_, "Error: %s\n", msg);
#line 92 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp1_ = gtk_builder_new ();
#line 92 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	builder = _tmp1_;
#line 821 "helpers.c"
	{
		GtkBuilder* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 94 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp2_ = builder;
#line 94 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp3_ = g_build_filename (CONSTANTS_PKGDATADIR, "generic_error.ui", NULL);
#line 94 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp4_ = _tmp3_;
#line 94 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		gtk_builder_add_from_file (_tmp2_, _tmp4_, &_inner_error0_);
#line 94 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_free0 (_tmp4_);
#line 94 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 838 "helpers.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 93 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		e = _inner_error0_;
#line 93 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_inner_error0_ = NULL;
#line 96 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp5_ = e;
#line 96 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp6_ = _tmp5_->message;
#line 96 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp7_ = g_strdup_printf ("Can't show the ERROR window: %s\n", _tmp6_);
#line 96 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp8_ = _tmp7_;
#line 96 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		g_print ("%s", _tmp8_);
#line 96 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_free0 (_tmp8_);
#line 97 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_error_free0 (e);
#line 97 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_object_unref0 (builder);
#line 97 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		return;
#line 872 "helpers.c"
	}
	__finally0:
#line 93 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_g_object_unref0 (builder);
#line 93 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 93 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		g_clear_error (&_inner_error0_);
#line 93 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		return;
#line 885 "helpers.c"
	}
#line 99 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp9_ = builder;
#line 99 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp10_ = gtk_builder_get_object (_tmp9_, "label_error");
#line 99 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_label_get_type (), GtkLabel));
#line 99 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	label = _tmp11_;
#line 100 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp12_ = label;
#line 100 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	gtk_label_set_label (_tmp12_, msg);
#line 101 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp13_ = builder;
#line 101 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp14_ = gtk_builder_get_object (_tmp13_, "error_dialog");
#line 101 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_dialog_get_type (), GtkDialog));
#line 101 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	w = _tmp15_;
#line 102 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	if (parent_window != NULL) {
#line 909 "helpers.c"
		GtkDialog* _tmp16_;
#line 103 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		_tmp16_ = w;
#line 103 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
		gtk_window_set_transient_for ((GtkWindow*) _tmp16_, parent_window);
#line 915 "helpers.c"
	}
#line 105 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp17_ = w;
#line 105 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp17_);
#line 106 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp18_ = w;
#line 106 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	gtk_dialog_run (_tmp18_);
#line 107 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp19_ = w;
#line 107 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	gtk_widget_hide ((GtkWidget*) _tmp19_);
#line 108 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_tmp20_ = w;
#line 108 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp20_);
#line 89 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_g_object_unref0 (w);
#line 89 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_g_object_unref0 (label);
#line 89 "/home/iurt/rpmbuild/BUILD/cronopete-4.15.1/src/helpers.vala"
	_g_object_unref0 (builder);
#line 939 "helpers.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

